Subject: Re: [patch net-next V4] net: introduce ethernet teaming device

From: Flavio Leitner <[email-masked]>
Date: Tue, 25 Oct 2011 11:22:56 -0200

On Mon, 24 Oct 2011 19:22:36 +0200
Michał Mirosław <[email-masked]> wrote:

> 2011/10/24 Jiri Pirko <[email-masked]>:
> > This patch introduces new network device called team. It supposes
> > to be very fast, simple, userspace-driven alternative to existing
> > bonding driver.
> [...]
> >  drivers/net/team/team.c                   | 1573
> > +++++++++++++++++++++++++++++
> > drivers/net/team/team_mode_activebackup.c |  152 +++
> > drivers/net/team/team_mode_roundrobin.c   |  107 ++
> 
> I think this mode-modularity is overkill. One mode will compile to at
> most a few hundred bytes of code+data, but will use at least 10 times
> that to get loaded and tracked properly. How often/how many more modes
> you anticipate to be introduced? You could just keep the modular
> design but drop the kernel module separation and maybe have modes
> conditionally compiled (for those from the embedded world squeezing
> every byte).
> 

Please keep the modes separated.  Security and embedded folks will
thank you.  If you are concerned with the overhead which still should
be small and doesn't impact performance, you can compile as built-in.
The good thing is that you can choose the best option for you while
doing the opposite doesn't offer that.

Also, if in the future we need to add module parameters, the namespace
is clean.

I would ask to keep it as the work is done already.

fbl